#include "DataBases.h"

//#include <gecode/kernel.hh>
//#include <gecode/float.hh>
//#include <gecode/driver.hh>
//#include <gecode/int.hh>
//#include <gecode/minimodel.hh>
//
//#include <gecode/search.hh>
//#include <gecode/search/parallel/engine.hh>

#include <sys/time.h>
#include <sys/resource.h>

#include <math.h>       /* sin .... */
#include <algorithm>    /* max .... */

#include <numeric> /* accumulate .... */

typedef std::vector<int> VECELE;
typedef std::vector<VECELE> MATELE;

using namespace std;
//using namespace Gecode;

double extern_val = 0.0;

///---- Variables ----///
int startDB_m_idx;
int nbItems, nbTrans_p, nbTrans_m, nbTrans, nbMetrics;
unsigned int nb_freq_patterns = 0; // To start to permute from (k+1)eme solution
unsigned int k = 0; // Top "k"
vector<int> item_freq_plus;
//double gp13_curr_value = 0.0;
MATELE Bplus, Bmoins, complementBplus; 			// Bases transactionelles B+, B-

MATELE topK_patterns; 			// To store Top k solutions
vector<vector<double> > topK_metrix; //
vector<vector<double> > statement_metrix; //
VECELE sol_pattern_tmp; // Temporary vector to copy a solution on the list (List_of_solutions)
std::vector<double> sol_metrix_tmp;
VECELE topK_freq_p; 			// To save Topk's freq+
VECELE topK_freq_m; 			// To save Topk's freq-
std::vector<double> metric; // // To store tarantula measure
string metric_name = "GP13";
vector<vector<int> > Solutions; // to store closed patterns
vector<int> Frequence_Solution; // to store frequency of each closed pattern
int CurFreq = 1;
int nbMeritFunCall = 0;
int firstOptim = 1;
float elapsed_time = 0.0f;
//bool *faults_arr;

vector<bool> is_fault_inserted_in_file;

//double _y_0 = 0.0;
//double _y_1 = 0.0;

vector<int> Code; // item's encoding
bool print_ = true; // allow print of encoding ,solutions and database under different representations
DataBases DataBasesInstance; // instance of DataBases class
//Search::Statistics GecodeStat; // Gecode's Statistics
//Gecode::Search::Options so;

///---- Fonction's prototypes ----///
void normalizeMetric(std::vector<std::pair<int, double> > &metric_vals, bool display);
//---------------------------------------------------------
int compute_P_Rank(int fault, VECELE Ranking);
//---------------------------------------------------------
int compute_O_Rank(int fault, VECELE Ranking);
//---------------------------------------------------------
int compute_O_Rank_FCPminer(
   int faulty_statement,
   VECELE top1_pattern,
   std::vector<std::pair<int, double> > sorted_metric,
   VECELE& merged_top1,
   bool use_merged_top1);
//---------------------------------------------------------
int compute_P_Rank_FCPminer(
   int faulty_statement,
   VECELE top1_pattern,
   std::vector<std::pair<int, double> > sorted_metric,
   VECELE& merged_top1,
   bool use_merged_top1);
//---------------------------------------------------------
int compute_metric_O_Rank(int faulty_statement, std::vector<std::pair<int, double> > sorted_metric);
//---------------------------------------------------------
int compute_metric_P_Rank(int faulty_statement, std::vector<std::pair<int, double> > sorted_metric);
//---------------------------------------------------------
double compute_Exam(int rank, int statements);
//---------------------------------------------------------
double compute_Exonerated_stmt(VECELE top1_pattern, int Number_of_statement);
//---------------------------------------------------------
double calcGP13(double ef, double ep)
{
   return ef * (1 + (1 / ((2 * ep) + ef)));
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
bool pairCompare(const std::pair<int, double> firstElt, const std::pair<int, double> secondElt)
{
   return firstElt.second > secondElt.second;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
bool pairCompareLess(const std::pair<int, double> firstElt, const std::pair<int, double> secondElt)
{
   return firstElt.second < secondElt.second;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
void sort_metric_vect(std::vector<std::pair<int, double> > &metric_vals, bool display)
{

   /*
    cout << "BEFORE SORTING " << endl;
    for (unsigned int i = 0; i < metric_vals.size(); i++) {
    cout << "item " << metric_vals.at(i).first << " has metric value "
    << metric_vals.at(i).second << endl;
    }*/

   std::sort(metric_vals.begin(), metric_vals.end(), pairCompare);

   //*
   if( display )
   {
      cout << "\n---------------------\nAFTER SORTING " << endl;
      for( unsigned int i = 0; i < metric_vals.size(); i++ )
      {
         cout << "item " << metric_vals.at(i).first << " has metric value " << metric_vals.at(i).second << endl;
      } //*/
   }
}
//---------------------------------------------------------
// Metrics data structures
//---------------------------------------------------------
std::vector<int> statements;

std::vector<std::pair<int, double> > AHP_cost_v;
std::vector<std::pair<int, double> > ER1b_metric_v;
std::vector<std::pair<int, double> > tar_metric_v;
std::vector<std::pair<int, double> > gp13_metric_v;
std::vector<std::pair<int, double> > ochiai_metric_v;
std::vector<std::pair<int, double> > ochiai2_metric_v;
std::vector<std::pair<int, double> > jaccard_metric_v;
std::vector<std::pair<int, double> > dominance_metric_v;
std::vector<std::pair<int, double> > barinel_metric_v;

std::vector<std::pair<int, double> > naish1_metric_v;
std::vector<std::pair<int, double> > naish2_metric_v;
std::vector<std::pair<int, double> > ample_metric_v;
std::vector<std::pair<int, double> > anderberg_metric_v;

std::vector<std::pair<int, double> > dice_metric_v;
std::vector<std::pair<int, double> > kulczynski2_metric_v;
std::vector<std::pair<int, double> > overlap_metric_v;
std::vector<std::pair<int, double> > goodman_metric_v;
std::vector<std::pair<int, double> > M2_metric_v;
std::vector<std::pair<int, double> > rogersTanimoto_metric_v;
std::vector<std::pair<int, double> > simpleMatching_metric_v;

// For sorting
std::vector<std::pair<int, double> > sorted_metric_v;

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
static double _tara(double F, double P, double ef, double ep)
{
   return (ef / F) / ((ef / F) + (ep / P));
}
//---------------------------------------------------------
//---------------------------------------------------------
static double _ochiai(double F, double ef, double ep)
{
   double denum = sqrt((ef + ep) * (F));
   if( denum != 0.0 )
   {
      return ef / denum;
   }
   return 0.0;
}
//---------------------------------------------------------
//---------------------------------------------------------
static double _ochiai2(double F, double P, double ef, double ep)
{
   double denum = sqrt((ef + ep) * (F - ef + P - ep) * (ef + P - ep) * (ep + F - ef));
   if( denum != 0.0 )
   {
      return ef * (P - ep) / denum;
   }
   else
      return 0.0;
}
//---------------------------------------------------------
//---------------------------------------------------------
double _jaccard(double F, double ef, double ep)
{
   return ef / (F + ep);
}
//---------------------------------------------------------
//---------------------------------------------------------
double _barinel(double ef, double ep)
{
   return 1.0 - (ep / (ep - ef));
}
//---------------------------------------------------------
//---------------------------------------------------------
double _er1b(double P, double ef, double ep)
{
   return ef - (ep / (P + 1));
}
//---------------------------------------------------------
//---------------------------------------------------------
double er1b(double ef, double ep)
{
   return _er1b((double)nbTrans_p, ef, ep);
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
double jaccard(double ef, double ep)
{
   return _jaccard((double)nbTrans_m, ef, ep);
}
//---------------------------------------------------------
//---------------------------------------------------------
double ochiai(double ef, double ep)
{
   return _ochiai((double)nbTrans_m, ef, ep);
}
//---------------------------------------------------------
//---------------------------------------------------------
double ochiai2(double ef, double ep)
{
   return _ochiai2((double)nbTrans_m, (double)nbTrans_p, ef, ep);
}
//---------------------------------------------------------
//---------------------------------------------------------
double gp13(double ef, double ep)
{
   if( (ep + ef) == 0 )
      return 0;
   return ef * (1 + (1 / ((2 * ep) + ef)));
}
//---------------------------------------------------------
//---------------------------------------------------------
double tara(double ef, double ep)
{
   if( (ef + ep) == 0 )
      return 0;
   return _tara((double)nbTrans_m, (double)nbTrans_p, ef, ep);
}
//---------------------------------------------------------
//---------------------------------------------------------
double barinel(double ef, double ep)
{
   if( (ef + ep) == 0 )
      return 0;
   return _barinel(ef, ep);
}
//---------------------------------------------------------
//---------------------------------------------------------

double ample(double F, double P, double ef, double ep)
{
   return fabs((ef / F) - (ep / P));
}

double naish1(double F, double P, double ef, double ep)
{
   if( ef == 0 )
      return P - ep;
   else
      return -1;
}

double naish2(double F, double P, double ef, double ep)
{
   return ef - (ep / (P + 1));
}

double anderberg(double F, double P, double ef, double ep)
{
   return ef / (ef + 2 * ep + 2 * (F - ef));
}

double dice(double F, double P, double ef, double ep)
{
   return (2 * ef) / (ep + F);
}

double kulczynski2(double F, double P, double ef, double ep)
{
   return 0.5 * ((ef / F) + (ef / (ef + ep)));
}

double overlap(double F, double P, double ef, double ep)
{
   double min = ef;
   if( min > ep )
      min = ep;
   if( min > F - ef )
      min = F - ef;

   if( min == 0 )
      return F;
   return ef / min;
}

double goodman(double F, double P, double ef, double ep)
{
   return (2 * ef - F + ef - ep) / (2 * ef + (F - ef) + ep);
}

double M2(double F, double P, double ef, double ep)
{
   return ef / (ef + (P - ep) + 2 * (F - ef) + 2 * ep);
}

double rogersTanimoto(double F, double P, double ef, double ep)
{
   return (ef + P - ep) / (ef + (P - ep) + 2 * (F - ef) + 2 * ep);
}

double simpleMatching(double F, double P, double ef, double ep)
{
   return (ef + P - ep) / (P + F);
}

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------
int test_case;
enum Test_case_enum
{
   Tarantula,
   Ochiai,
   Ochiai2,
   GP13,
   Jaccard,
   Dominance,
   AHP,
   Barinel,
   Ample,
   Naish1,
   Naish2,
   Anderberg,
   Dice,
   Kulczynski2,
   Overlap,
   Goodman,
   M_Two,
   RogersTanimoto,
   SimpleMatching,
   ER1b
};

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

void eval_suspic_metric(int test_case0)
{
//	printf("------- Computing suspiciousness using metrics ------\n");
//	printf("-----------------------------------------------------\n");

//	cout << "## nbItems >> " << nbItems << endl;

   for( int j = 0; j < nbItems; j++ )
   {
      int ef = 0, ep = 0;
      for( int i = 0; i < nbTrans_p; i++ )
      {
         if( Bplus[i][j] == 1 )
         {
            ep = ep + 1;
         }
      }
      for( int i = 0; i < nbTrans_m; i++ )
      {
         if( Bmoins[i][j] == 1 )
         {
            ef = ef + 1;
         }
      }
// computing suspicisousness
      switch( test_case0 )
      {
      case Tarantula:
      {
         //cout << "tar = " << tara(ef, ep) << endl;
         tar_metric_v.push_back(std::make_pair(j, tara(ef, ep)));
         break;
      }
      case Ochiai:
      {
         //printf("------- get_all_metrics >> Ochiai \n");
         ochiai_metric_v.push_back(std::make_pair(j, ochiai(ef, ep)));
         break;
      }
      case Ochiai2:
      {
         //printf("------- get_all_metrics >> Ochiai2 \n");
         ochiai2_metric_v.push_back(std::make_pair(j, ochiai2(ef, ep)));
         break;
      }
      case GP13:
      {
         //printf("------- get_all_metrics >> GP13 \n");
         gp13_metric_v.push_back(std::make_pair(j, gp13(ef, ep)));
         break;
      }
      case Jaccard:
      {
         //printf("------- get_all_metrics >> Jaccard \n");
         jaccard_metric_v.push_back(std::make_pair(j, jaccard(ef, ep)));
         break;
      }
      case Dominance:
      {
//			cout << "-------Dominance std::make_pair(j, ef): " << j << " " << ef
//					<< endl;
         std::string str = std::to_string(ef) + "." + std::to_string(nbTrans_p - ep);
         dominance_metric_v.push_back(std::make_pair(j, atof(str.c_str())));
         break;
      }
      case Barinel:
      {
         barinel_metric_v.push_back(std::make_pair(j, barinel(ef, ep)));
         // The SBFL Barinel formulae is: 1 – passed(e)/(passed(e)-failed(e))
         break;
      }
      case Ample:
      {
         ample_metric_v.push_back(std::make_pair(j, ample((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }
      case Naish1:
      {
         naish1_metric_v.push_back(std::make_pair(j, naish1((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }
      case Naish2:
      {
         naish2_metric_v.push_back(std::make_pair(j, naish2((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case Anderberg:
      {
         anderberg_metric_v.push_back(std::make_pair(j, anderberg((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }
/////
      case Dice:
      {
         dice_metric_v.push_back(std::make_pair(j, dice((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case Kulczynski2:
      {
         kulczynski2_metric_v.push_back(std::make_pair(j, kulczynski2((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case Overlap:
      {
         overlap_metric_v.push_back(std::make_pair(j, overlap((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case Goodman:
      {
         goodman_metric_v.push_back(std::make_pair(j, goodman((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case M_Two:
      {
         M2_metric_v.push_back(std::make_pair(j, M2((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case RogersTanimoto:
      {
         rogersTanimoto_metric_v.push_back(std::make_pair(j, rogersTanimoto((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }

      case SimpleMatching:
      {
         simpleMatching_metric_v.push_back(std::make_pair(j, simpleMatching((double)nbTrans_m, (double)nbTrans_p, ef, ep)));
         break;
      }
      case ER1b:
      {
         //printf("------- get_all_metrics >> Ochiai2 \n");
         ER1b_metric_v.push_back(std::make_pair(j, er1b(ef, ep)));
         break;
      }

//			Dice, Kulczynski2, Overlap, Goodman, M_Two, RogersTanimoto, SimpleMatching

      }
   } // end_for

}

//--------------------------------------------------

void sort_metrics(int test_case0)
{
   switch( test_case0 )
   {
   case Tarantula:
   {
      sort_metric_vect(tar_metric_v, false);
      sorted_metric_v = tar_metric_v;
      break;
   }
   case Ochiai:
   {
      sort_metric_vect(ochiai_metric_v, false);
      sorted_metric_v = ochiai_metric_v;
      break;
   }
   case Ochiai2:
   {
      sort_metric_vect(ochiai2_metric_v, false);
      sorted_metric_v = ochiai2_metric_v;
      break;
   }
   case GP13:
   {
      sort_metric_vect(gp13_metric_v, false);
      sorted_metric_v = gp13_metric_v;
      break;
   }
   case Jaccard:
   {
      sort_metric_vect(jaccard_metric_v, false);
      sorted_metric_v = jaccard_metric_v;
      break;
   }
   case Dominance:
   {
      sort_metric_vect(dominance_metric_v, false);
      sorted_metric_v = dominance_metric_v;
      break;
   }
   case AHP:
   {
      sort_metric_vect(AHP_cost_v, false);
      sorted_metric_v = AHP_cost_v;
      break;
   }
   case Barinel:
   {
      sort_metric_vect(barinel_metric_v, false);
      sorted_metric_v = barinel_metric_v;
      break;
   }
   case Ample:
   {
      sort_metric_vect(ample_metric_v, false);
      sorted_metric_v = ample_metric_v;
      break;
   }
   case Naish1:
   {
      sort_metric_vect(naish1_metric_v, false);
      sorted_metric_v = naish1_metric_v;
      break;
   }
   case Naish2:
   {
      sort_metric_vect(naish2_metric_v, false);
      sorted_metric_v = naish2_metric_v;
      break;
   }
   case Anderberg:
   {
      sort_metric_vect(anderberg_metric_v, false);
      sorted_metric_v = anderberg_metric_v;
      break;
   }
////
   case Dice:
   {
      sort_metric_vect(dice_metric_v, false);
      sorted_metric_v = dice_metric_v;
      break;
   }
   case Kulczynski2:
   {
      sort_metric_vect(kulczynski2_metric_v, false);
      sorted_metric_v = kulczynski2_metric_v;
      break;
   }
   case Overlap:
   {
      sort_metric_vect(overlap_metric_v, false);
      sorted_metric_v = overlap_metric_v;
      break;
   }
   case Goodman:
   {
      sort_metric_vect(goodman_metric_v, false);
      sorted_metric_v = goodman_metric_v;
      break;
   }
   case M_Two:
   {
      sort_metric_vect(M2_metric_v, false);
      sorted_metric_v = M2_metric_v;
      break;
   }
   case RogersTanimoto:
   {
      sort_metric_vect(rogersTanimoto_metric_v, false);
      sorted_metric_v = rogersTanimoto_metric_v;
      break;
   }
   case SimpleMatching:
   {
      sort_metric_vect(simpleMatching_metric_v, false);
      sorted_metric_v = simpleMatching_metric_v;
      break;
   }
   case ER1b:
   {
      sort_metric_vect(ER1b_metric_v, false);
      sorted_metric_v = ER1b_metric_v;
      break;
   }
//		Dice, Kulczynski2, Overlap, Goodman, M_Two, RogersTanimoto, SimpleMatching
   }
}
//--------------------------------------------------
//--------------------------------------------------

Test_case_enum to_test_case(const std::string& s)
{
   if( s == "1" )
   {
      metric_name = "Tarantula";
      return Tarantula;
   }
   if( s == "2" )
   {
      metric_name = "Ochiai";
      return Ochiai;
   }
   if( s == "3" )
   {
      metric_name = "Ochiai2";
      return Ochiai2;
   }
   if( s == "4" )
   {
      metric_name = "GP13";
      return GP13;
   }
   if( s == "5" )
   {
      metric_name = "Jaccard";
      return Jaccard;
   }
   if( s == "6" )
   {
      metric_name = "Dominance";
      return Dominance;
   }
   if( s == "7" )
   {
      metric_name = "AHP";
      return AHP;
   }
   if( s == "8" )
   {
      metric_name = "Barinel";
      return Barinel;
   }
   throw std::runtime_error("invalid conversion from text to periods");
}
//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------
std::string intToString(int i)
{
   std::ostringstream oss;
   oss << i;
   return oss.str();
}
//--------------------------------------------------
//--------------------------------------------------
std::string doubleToString(double i)
{
   std::ostringstream oss;
   oss << i;
   return oss.str();
}
//--------------------------------------------------
//--------------------------------------------------
std::string splitFilename(const std::string& str)
{
//  std::cout << "Splitting: " << str << '\n';
   std::size_t found = str.find_last_of("/\\");
//  std::cout << " path: " << str.substr(0,found) << '\n';
   return str.substr(found + 1);
}
//--------------------------------------------------
//--------------------------------------------------

//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------
void calc_ExamScores_metric(
   const string& res_Dir,
   const string& root_benchs_Dir,
   const string& file_in_dataset_Dir,
   int testcase,
   int fault)
{

   int P_rank = 0;
   int O_rank = 0;
   double P_exam = 0.0;
   double O_exam = 0.0;
   double Exonerated_exam = 0.0;
   std::vector<std::pair<int, double> > sorted_metric00;
   string myMetric = "";
   switch( testcase )
   {
   case Tarantula:
   {
      sorted_metric_v = tar_metric_v;
      myMetric = "Tarantula";
      break;
   }
   case Ochiai:
   {
      sorted_metric_v = ochiai_metric_v;
      myMetric = "Ochiai";
      break;
   }
   case Ochiai2:
   {
      sorted_metric_v = ochiai2_metric_v;
      myMetric = "Ochiai2";
      break;
   }
   case GP13:
   {
      sorted_metric_v = gp13_metric_v;
      myMetric = "GP13";
      break;
   }
   case Jaccard:
   {
      sorted_metric_v = jaccard_metric_v;
      myMetric = "Jaccard";
      break;
   }
   case Dominance:
   {
      sorted_metric_v = dominance_metric_v;
      myMetric = "Dominance";
      break;
   }
   case AHP:
   {
      sorted_metric_v = AHP_cost_v;
      myMetric = "AHP";
      break;
   }
   case Barinel:
   {
      sorted_metric_v = barinel_metric_v;
      myMetric = "Barinel";
      break;
   }
   case Ample:
   {
      sorted_metric_v = ample_metric_v;
      myMetric = "Ample";
      break;
   }
   case Naish1:
   {
      sorted_metric_v = naish1_metric_v;
      myMetric = "Naish1";
      break;
   }
   case Naish2:
   {
      sorted_metric_v = naish2_metric_v;
      myMetric = "Naish2";
      break;
   }
   case Anderberg:
   {
      sorted_metric_v = anderberg_metric_v;
      myMetric = "Anderberg";
      break;
   }

   case Dice:
   {
      sorted_metric_v = dice_metric_v;
      myMetric = "Dice";
      break;
   }

   case Kulczynski2:
   {
      sorted_metric_v = kulczynski2_metric_v;
      myMetric = "Kulczynski2";
      break;
   }

   case Overlap:
   {
      sorted_metric_v = overlap_metric_v;
      myMetric = "Overlap";
      break;
   }

   case Goodman:
   {
      sorted_metric_v = goodman_metric_v;
      myMetric = "Goodman";
      break;
   }

   case M_Two:
   {
      sorted_metric_v = M2_metric_v;
      myMetric = "M_Two";
      break;
   }

   case RogersTanimoto:
   {
      sorted_metric_v = rogersTanimoto_metric_v;
      myMetric = "RogersTanimoto";
      break;
   }

   case SimpleMatching:
   {
      sorted_metric_v = simpleMatching_metric_v;
      myMetric = "SimpleMatching";
      break;
   }
   case ER1b:
   {
      sorted_metric_v = ER1b_metric_v;
      myMetric = "ER1b";
      break;
   }
//	Dice, Kulczynski2, Overlap, Goodman, M_Two, RogersTanimoto, SimpleMatching
   } // end switch

   ofstream result_model((res_Dir + "/" + myMetric + "_" + splitFilename(root_benchs_Dir)
//					+ "_space_" + file_in_dataset_Dir + "-" + intToString(fault)).c_str(),
      + "_" + file_in_dataset_Dir + "-" + intToString(fault)).c_str(), ios::app);

//	cout << "\t+++++ calc_ExamScores_metric ......" << testcase << " " << fault
//			<< sorted_metric_v.size() << endl;
//
//	for (unsigned int k = 0; k < sorted_metric_v.size(); k++) {
//		cout << sorted_metric_v.at(k).first << " ";
//	}
//	cout << endl;

   P_rank = compute_metric_P_Rank(fault, sorted_metric_v);
   O_rank = compute_metric_O_Rank(fault, sorted_metric_v);
   P_exam = compute_Exam(P_rank, nbItems);
   O_exam = compute_Exam(O_rank, nbItems);

   result_model << "P_rank ====== " << P_rank << "\nO_rank ====== " << O_rank << "\nP_exam(%) === " << P_exam
      << "\nO_exam(%) === " << O_exam << "\nD_exam(%) === " << P_exam - O_exam << endl;
}
//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

///---- Main() ----///
int main(int argc, char* argv[])
{

   string bPlus_filename = "Bplus";
   string bMoins_filename = "Bmoins";

   string root_benchs_Dir = "";
   string dataset_Dir = "";
   string res_Dir = "";

// ------ CPU time Total ------
   struct rusage usage;
   struct timeval end;
   getrusage(RUSAGE_SELF, &usage);

// Reading Parameters
   if( argc < 2 )
   {
      cerr << "Error on inputs data : missing parameter(s)" << endl;
      cerr
         << "usage: ./GC4CIM fullPath-benchDir dataset_Dir metric-number fullPath-resDir fminsup max_reoptimizations nbFaults f1 f2 ..."
         << endl;
      return 1;
   }

   root_benchs_Dir = argv[1];
   dataset_Dir = argv[2]; //"";
   // test_case = to_test_case(argv[3]);
   res_Dir = argv[3];
   // double fminsup = atof(argv[5]); // minsup relative (%)
   // int fminsize = 1; // size min (default = 0)

   string file_in_dataset_Dir = dataset_Dir;
   std::replace(file_in_dataset_Dir.begin(), file_in_dataset_Dir.end(), '/', '_');

// ------ CPU time only Processing database ------
   struct rusage usage0;
   struct timeval end0;
   getrusage(RUSAGE_SELF, &usage0);

// Parser les bases de transactions
// LOADING B+
   int loadData0 = 1;
   loadData0 = DataBasesInstance.GetData(root_benchs_Dir + "/" + dataset_Dir + "/Base/Bplus", true); // Load original database (// Load B+ database)

   cout << "AFTER READING " << loadData0 << endl;
   if( loadData0 == -1 )
   {
      cerr << "Main: ERROR in reading Bplus file" << endl;
      return 0;
   }

   startDB_m_idx = DataBasesInstance.tmp_Boolean_Base.size();
   Bplus = std::vector<vector<int> >(DataBasesInstance.tmp_Boolean_Base);
   DataBasesInstance.tmp_Boolean_Base.clear();

   nbItems = Bplus[0].size();
   cout << "nbItems : " << k << endl;

   bool complBasePlus = false;

   if( complBasePlus )
   {
      cout << "LOADING complement B+.... " << endl;
      // LOADING complement B+
      for( unsigned int i = 0; i < Bplus.size(); i++ )
      {
         vector<int> temporary_Bplus;
         for( unsigned int j = 0; j < Bplus[0].size(); j++ )
         {
            temporary_Bplus.push_back(1 - Bplus[i][j]);
         }
         complementBplus.push_back(temporary_Bplus);
         temporary_Bplus.clear();
      }
      cout << endl;
   }

// LOADING B-
   cout << "LOADING B-.... " << endl;
   loadData0 = DataBasesInstance.GetData(root_benchs_Dir + "/" + dataset_Dir + "/Base/Bmoins", false); // Load B- database
   if( loadData0 == -1 )
   {
      cerr << "Main: ERROR in reading Bmoins file" << endl;
      return 0;
   }

   cout << "-----------------------" << endl;

   Bmoins = std::vector<vector<int> >(DataBasesInstance.Boolean_Base);

   if( complBasePlus )
   {
      cout << "LOADING complement B+.... " << endl;
      for( unsigned int i = 0; i < complementBplus.size(); i++ )
      {
         DataBasesInstance.Boolean_Base.push_back(complementBplus[i]);
      }
   }

   nbTrans_p = Bplus.size();
   nbTrans_m = Bmoins.size();
   nbItems = Bplus[0].size();
   nbTrans = nbTrans_p + nbTrans_m;
   k = nbItems;

   cout << "nbTrans_p " << nbTrans_p << endl;
   cout << "nbTrans_m " << nbTrans_m << endl;
   cout << "nbItems " << nbItems << endl;

   //int minsup = 1; //freqMin00;
   //cout << "frequence minimale ======== " << minsup << endl;
   DataBasesInstance.Create_Vertical_DataBase(); // Create vertical representation (bitvector)

// ------ End timer only Processing database ------
   getrusage(RUSAGE_SELF, &usage0);
   end0 = usage0.ru_utime;
   printf("USER Time (Only pré-traitement) =  %ld.%lds\n", end0.tv_sec, end0.tv_usec);

// ------ CPU time only resolution ------
//	float time;
   clock_t t1, t2, t3;
   t1 = clock();

   bool use_AHP_only = true;

//--------------------------------------------
// Calc stmt suspic values
//--------------------------------------------
   //TODO Eval suspecisous metrics
   if( !use_AHP_only )
   {
      eval_suspic_metric(Tarantula);
      eval_suspic_metric(Ochiai2);
      eval_suspic_metric(Ochiai);
      eval_suspic_metric(Dominance);
      eval_suspic_metric(Jaccard);
      eval_suspic_metric(Barinel);
      eval_suspic_metric(Anderberg);
      eval_suspic_metric(Dice);
      eval_suspic_metric(Kulczynski2);
      eval_suspic_metric(Overlap);
      eval_suspic_metric(Goodman);
      eval_suspic_metric(M_Two);
      eval_suspic_metric(RogersTanimoto);
      eval_suspic_metric(SimpleMatching);
      eval_suspic_metric(Naish1);
      eval_suspic_metric(Naish2);
      eval_suspic_metric(GP13);
      eval_suspic_metric(Ample);
      eval_suspic_metric(ER1b);
   }
   else
   {
      eval_suspic_metric(GP13);
      eval_suspic_metric(ER1b);
      eval_suspic_metric(Naish2);
      eval_suspic_metric(M_Two);
      eval_suspic_metric(Ochiai);
      eval_suspic_metric(Jaccard);
      eval_suspic_metric(Tarantula);
      eval_suspic_metric(Ample);
   }
//	Dice, Kulczynski2, Overlap, Goodman, M_Two, RogersTanimoto, SimpleMatching
   bool display = false;
//-------------------------
// 1- Normalizing metrics
//-------------------------
   cout << "##### Tarantula and Jaccard have already been normalized\n." << endl;
   cout << "##### Normalizing GP13, OCHAI, Anderberg and Ample vectors......." << endl;

   /*** Display metrics values befores normalizing ***/
   if( display )
      for( int i = 0; i < nbItems; i++ )
      {
         cout << roundf(tar_metric_v.at(i).second * 100) / 100 << " & " << roundf(ochiai_metric_v.at(i).second * 100) / 100
            << " & " << roundf(ochiai2_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(jaccard_metric_v.at(i).second * 100) / 100 << " & " << roundf(gp13_metric_v.at(i).second * 100) / 100
            << " & " << roundf(ample_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(naish2_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(anderberg_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(dice_metric_v.at(i).second * 100) / 100 << " & " << roundf(goodman_metric_v.at(i).second * 100) / 100
            << " & " << roundf(M2_metric_v.at(i).second * 100) / 100 << " \\\\ \\hline " << endl;
      }

   //-------------------- METRICS NOMRMALIZATION ----------------------//
   if( !use_AHP_only )
   {
      normalizeMetric(barinel_metric_v, display);
      normalizeMetric(tar_metric_v, display);
      normalizeMetric(dominance_metric_v, display);
      normalizeMetric(naish1_metric_v, display);
      normalizeMetric(naish2_metric_v, display);
      normalizeMetric(dice_metric_v, display);
      normalizeMetric(overlap_metric_v, display);
      normalizeMetric(anderberg_metric_v, display);
      normalizeMetric(kulczynski2_metric_v, display);
      normalizeMetric(goodman_metric_v, display);
      normalizeMetric(M2_metric_v, display);
      normalizeMetric(rogersTanimoto_metric_v, display);
      normalizeMetric(simpleMatching_metric_v, display);
      normalizeMetric(jaccard_metric_v, display);
      normalizeMetric(gp13_metric_v, display);
      normalizeMetric(ochiai_metric_v, display);
      normalizeMetric(ochiai2_metric_v, display);
      normalizeMetric(ample_metric_v, display);
      normalizeMetric(ER1b_metric_v, display);
   }
   else
   {
      normalizeMetric(gp13_metric_v, display);
      normalizeMetric(ER1b_metric_v, display);
      normalizeMetric(naish2_metric_v, display);
      normalizeMetric(M2_metric_v, display);
      normalizeMetric(ochiai_metric_v, display);
      normalizeMetric(jaccard_metric_v, display);
      normalizeMetric(tar_metric_v, display);
      normalizeMetric(ample_metric_v, display);
   }
//	cout << "\n---------- DISPLAYING NORMALIZED METRCS ......." << endl;
   if( display )
      for( int i = 0; i < nbItems; i++ )
      {
         cout << roundf(tar_metric_v.at(i).second * 100) / 100 << " & " << roundf(ochiai_metric_v.at(i).second * 100) / 100
            << " & " << roundf(ochiai2_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(jaccard_metric_v.at(i).second * 100) / 100 << " & " << roundf(gp13_metric_v.at(i).second * 100) / 100
            << " & " << roundf(ample_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(naish2_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(anderberg_metric_v.at(i).second * 100) / 100 << " & "
            << roundf(dice_metric_v.at(i).second * 100) / 100 << " & " << roundf(goodman_metric_v.at(i).second * 100) / 100
            << " & " << roundf(M2_metric_v.at(i).second * 100) / 100 << " \\\\ \\hline " << endl;
      }

   //TODO AHP
   ///////////////  AHP part //////////////////
   cout << "\n############ ROC based Weights elicitation " << endl;

   nbMetrics = 8; // 8

   vector<int> ROC_pref;
   vector<double> ROC_weights;
   ROC_pref.push_back(1); // GP13
   ROC_pref.push_back(1); // ER1b
   ROC_pref.push_back(1); // Naish2
   ROC_pref.push_back(2); // M2
   ROC_pref.push_back(3); // Ochiai
   ROC_pref.push_back(4); // Jacc
   ROC_pref.push_back(5); // Tar
   ROC_pref.push_back(6); // Ample

   for( int i = 0; i < nbMetrics; i++ )
   {
      double val00 = 0.0;
      for( int k = i; k < nbMetrics; k++ )
      {
         val00 = val00 + 1.0 / ROC_pref.at(k);
      }

      ROC_weights.push_back(val00 / (double)nbMetrics);

   }

   for( int i = 0; i < nbMetrics; i++ )
   {
      cout << "\n############ ROC " << i << "  = " << ROC_weights.at(i) << endl;
   }

   for( int i = 0; i < nbItems; i++ )
   {
      // adding [Tar, GP13, Jaccard, Ochiai, Ochiai2]
//    sol_metrix_tmp.push_back(anderberg_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(ochiai2_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(dice_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(goodman_metric_v.at(i).second);

      sol_metrix_tmp.push_back((gp13_metric_v.at(i).second));
      sol_metrix_tmp.push_back(ER1b_metric_v.at(i).second);
      sol_metrix_tmp.push_back(naish2_metric_v.at(i).second);
      sol_metrix_tmp.push_back(M2_metric_v.at(i).second);
      sol_metrix_tmp.push_back(ochiai_metric_v.at(i).second);
      sol_metrix_tmp.push_back(jaccard_metric_v.at(i).second);
      sol_metrix_tmp.push_back(tar_metric_v.at(i).second);
      sol_metrix_tmp.push_back(ample_metric_v.at(i).second);

      //      sol_metrix_tmp.push_back(kulczynski2_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(naish1_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(rogersTanimoto_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(simpleMatching_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(overlap_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(dominance_metric_v.at(i).second);
//    sol_metrix_tmp.push_back(barinel_metric_v.at(i).second);

      if( display )
      {
         cout << "\n############ BEFORE SORTING STATEMENT " << i << ": " << endl;
         for( unsigned int j = 0; j < sol_metrix_tmp.size(); j++ )
         {
            cout << sol_metrix_tmp[j] << "\t ";
         }
         cout << endl;
      }
      statement_metrix.push_back(sol_metrix_tmp);

      sol_metrix_tmp.clear();
   }

   cout << "\n---------- DISPLAYING SORTED NORMALIZED METRCS ......." << endl;

   if( display )
      for( unsigned int i = 0; i < statement_metrix.size(); i++ )
      {
         cout << roundf(statement_metrix[i][0] * 100) / 100 << " & " << roundf(statement_metrix[i][1] * 100) / 100 << " & "
            << roundf(statement_metrix[i][2] * 100) / 100 << " & " << roundf(statement_metrix[i][3] * 100) / 100 << " & "
            << roundf(statement_metrix[i][4] * 100) / 100 << " & " << roundf(statement_metrix[i][5] * 100) / 100 << " & "
            << roundf(statement_metrix[i][6] * 100) / 100 << " & " << roundf(statement_metrix[i][7] * 100) / 100 << " & "
            << roundf(statement_metrix[i][8] * 100) / 100 << " & " << roundf(statement_metrix[i][9] * 100) / 100 << " & "
            << roundf(statement_metrix[i][10] * 100) / 100 << " \\\\ \\hline " << endl;
      }

   //-----------------------------------------
   // 4 - Learning Weighted sum coefficients
   //-----------------------------------------
   std::vector<double> eigenVector;

   // WS elicited weights
   // 09 avril
   /*
    eigenVector.push_back(0.6938); // GP13
    eigenVector.push_back(0.6938); // Naish2
    eigenVector.push_back(0.1800); //Ochiai
    eigenVector.push_back(0.0705); // Ample
    //*/

   // 24/11/2018
   /*
    eigenVector.push_back(0.625411); // GP13
    eigenVector.push_back(0.625411); // Naish2
    eigenVector.push_back(0.396011); //M2
    eigenVector.push_back(0.231867); // Ochiai
    eigenVector.push_back(0.0844701); // Ample
    */
   // 25/11/2018
   /*
    eigenVector.push_back(0.706661); // GP13
    eigenVector.push_back(0.581831); // Naish2
    eigenVector.push_back(0.329258); //M2
    eigenVector.push_back(0.206135); // Ochiai
    eigenVector.push_back(0.105834); // Ample
    */

   // 03/12/2018
   /* T1
    eigenVector.push_back(0.487457); // GP13
    eigenVector.push_back(0.487457); // ER1b
    eigenVector.push_back(0.487457); // Naish2
    eigenVector.push_back(0.428123); //M2
    eigenVector.push_back(0.286462); // Ochiai
    eigenVector.push_back(0.104936); // Jaccard
    eigenVector.push_back(0.0902883); // Tarantula
    eigenVector.push_back(0.0514315); // Ample
    //*/

   /* T2
    eigenVector.push_back(0.48543); // GP13
    eigenVector.push_back(0.48543); // ER1b
    eigenVector.push_back(0.48543); // Naish2
    eigenVector.push_back(0.423886); //M2
    eigenVector.push_back(0.297558); // Ochiai
    eigenVector.push_back(0.120597); // Jaccard
    eigenVector.push_back(0.0863653); // Tarantula
    eigenVector.push_back(0.0533747); // Ample
    //*/

   /* T3 - Learning from data -Best so far - after normalized AHP coeff
    eigenVector.push_back(0.49844); // GP13
    eigenVector.push_back(0.49844); // ER1b
    eigenVector.push_back(0.49844); // Naish2
    eigenVector.push_back(0.418474); //M2
    eigenVector.push_back(0.238903); // Ochiai
    eigenVector.push_back(0.108116); // Jaccard
    eigenVector.push_back(0.0884924); // Tarantula
    eigenVector.push_back(0.0543969); // Ample
    //*/

   /* T4 - after normalized AHP coeff
    eigenVector.push_back(0.691983); // GP13
    //   eigenVector.push_back(0.49844); // ER1b
    //   eigenVector.push_back(0.49844); // Naish2
    eigenVector.push_back(0.597972); //M2
    eigenVector.push_back(0.350084); // Ochiai
    eigenVector.push_back(0.149598); // Jaccard
    eigenVector.push_back(0.118724); // Tarantula
    eigenVector.push_back(0.0674894); // Ample
    //*/

   /* T5 ROC weighting - after normalized AHP coeff
    eigenVector.push_back(0.55625); // ER1b
    eigenVector.push_back(0.43125); // Naish2
    eigenVector.push_back(0.30625); // GP13
    eigenVector.push_back(0.18125); //M2
    eigenVector.push_back(0.11875); // Ochiai
    eigenVector.push_back(0.0770833); // Jaccard
    eigenVector.push_back(0.0458333); // Tarantula
    eigenVector.push_back(0.0208333); // Ample
    //*/

   /* AHP-ROC - after normalized AHP coeff
    eigenVector.push_back(0.55405); // GP13
    eigenVector.push_back(0.48947); // ER1b
    eigenVector.push_back(0.418965); // Naish2
    eigenVector.push_back(0.334185); //M2
    eigenVector.push_back(0.280879); // Ochiai
    eigenVector.push_back(0.226017); // Jaccard
    eigenVector.push_back(0.169007); // Tarantula
    eigenVector.push_back(0.0877317); // Ample
    //*/

   /* Learning AHP weights -
    eigenVector.push_back( ); // GP13
    eigenVector.push_back( ); // ER1b
    eigenVector.push_back( ); // Naish2
    eigenVector.push_back( ); //M2
    eigenVector.push_back( ); // Ochiai
    eigenVector.push_back( ); // Jaccard
    eigenVector.push_back( ); // Tarantula
    eigenVector.push_back( ); // Ample
    //*/

   /* Learning AHP weights - 1
    eigenVector.push_back(0.525403); // GP13
    eigenVector.push_back(0.525403); // ER1b
    eigenVector.push_back(0.525403); // Naish2
    eigenVector.push_back(0.347927); //M2
    eigenVector.push_back(0.185629); // Ochiai
    eigenVector.push_back(0.0804948); // Jaccard
    eigenVector.push_back(0.0566333); // Tarantula
    eigenVector.push_back(0.0816); // Ample
    //*/

   /* Learning AHP weights - 2
    eigenVector.push_back(0.337657); // GP13
    eigenVector.push_back(0.298765); // ER1b
    eigenVector.push_back(0.272088); // Naish2
    eigenVector.push_back(0.694932); //M2
    eigenVector.push_back(0.411056); // Ochiai
    eigenVector.push_back(0.205432); // Jaccard
    eigenVector.push_back(0.156653); // Tarantula
    eigenVector.push_back(0.0636801); // Ample
    //*/

   /* Learning AHP weights - 3
    eigenVector.push_back(0.474108 ); // GP13
    eigenVector.push_back( 0.602073); // ER1b
    eigenVector.push_back(0.474108 ); // Naish2
    eigenVector.push_back( 0.256564); //M2
    eigenVector.push_back(0.266799 ); // Ochiai
    eigenVector.push_back(0.160568 ); // Jaccard
    eigenVector.push_back(0.148385 ); // Tarantula
    eigenVector.push_back(0.0560824 ); // Ample
    //*/
   /* Learning AHP weights - 4
    eigenVector.push_back(0.45086 ); // GP13
    eigenVector.push_back(0.489172 ); // ER1b
    eigenVector.push_back( 0.469626); // Naish2
    eigenVector.push_back(0.293794 ); //M2
    eigenVector.push_back( 0.446745); // Ochiai
    eigenVector.push_back(0.20046 ); // Jaccard
    eigenVector.push_back( 0.0539121); // Tarantula
    eigenVector.push_back( 0.0888891); // Ample
    //*/

   /* Learning AHP weights - 5
    eigenVector.push_back(0.480681 ); // GP13
    eigenVector.push_back(0.522164 ); // ER1b
    eigenVector.push_back( 0.522164); // Naish2
    eigenVector.push_back( 0.322043); //M2
    eigenVector.push_back(0.155726 ); // Ochiai
    eigenVector.push_back( 0.184923); // Jaccard
    eigenVector.push_back( 0.0603785); // Tarantula
    eigenVector.push_back( 0.240481); // Ample
    //*/

   /* Learning AHP weights - 6
    eigenVector.push_back(0.409456); // GP13
    eigenVector.push_back(0.501659); // ER1b
    eigenVector.push_back(0.501659); // Naish2
    eigenVector.push_back(0.430385); //M2
    eigenVector.push_back(0.263149); // Ochiai
    eigenVector.push_back(0.218261); // Jaccard
    eigenVector.push_back(0.0528799); // Tarantula
    eigenVector.push_back(0.155274); // Ample
    //*/

   ///* RUNNING EXAMPLE AHP weights
//   eigenVector.push_back(0.15); // GP13
//   eigenVector.push_back(0.07); // Ochiai
//   eigenVector.push_back(0.04); // Jaccard
//   eigenVector.push_back(0.25); // Tarantula
//   eigenVector.push_back(0.49); // Ample
   //*/
   ///* Active Learning AHP weights
   eigenVector.push_back(0.474); // GP13
   eigenVector.push_back(0.602); // ER1b
   eigenVector.push_back(0.474); // Naish2
   eigenVector.push_back(0.257); //M2
   eigenVector.push_back(0.267); // Ochiai
   eigenVector.push_back(0.161); // Jaccard
   eigenVector.push_back(0.148); // Tarantula
   eigenVector.push_back(0.057); // Ample
   //*/

   //-----------------------------
   // 5 - Computing AHP utilities
   //-----------------------------
   for( unsigned int i = 0; i < statement_metrix.size(); i++ )
   {
      //sum (metrics values of Stmt_i, AHPcoeffs)
      if( true )
      {
         std::cout << "The AHP scalar product is: "
            << std::inner_product(std::begin(eigenVector), std::end(eigenVector), std::begin(statement_metrix[i]), 0.0)
            << endl;
      }
      AHP_cost_v.push_back(
         std::make_pair(i,
            std::inner_product(std::begin(eigenVector), std::end(eigenVector), std::begin(statement_metrix[i]), 0.0)
            // + std::accumulate(statement_metrix[i].begin(),
            //	statement_metrix[i].end(), 0)
               ));
   }
   cout << "\n------------------------" << endl;
   //*/
//------------------------------------------------------//
//------------------------------------------------------//
//------------------------------------------------------//
//------------------------------------------------------
// ------ End timer only resolution ------
//------------------------------------------------------
   t2 = clock();
   elapsed_time = (float)(t2 - t1) / CLOCKS_PER_SEC;
   printf("CPU Time resolution  = %f\n", elapsed_time);

//##################################################################

//-------------------- FAULT LOCALIZATION ----------------------------//

//------------------------------------------------------------------------
// How to compute ranks of non localized faults in the first top1 pattern?
//------------------------------------------------------------------------
//A-initialize merged_top_1 with top1 pattern

   printf("--------------------------------------------------\n");
   printf("-----------      FAULT LOCALIZATION     ----------\n");
   printf("--------------------------------------------------\n");

//--------------------------------------------------------------------//
/// Compute Exam_Scores
//--------------------------------------------------------------------//
   int faults_SIZE = atoi(argv[4]);
   cout << "## \t faults_SIZE  >> " << faults_SIZE << endl;

   if( !use_AHP_only )
   {
      cout << "+++++ TAR ++++ " << endl;
      sort_metric_vect(tar_metric_v, true);

      cout << "+++++ Ochiai ++++ " << endl;
      sort_metric_vect(ochiai2_metric_v, true);

      cout << "+++++ Jacc ++++ " << endl;
      sort_metric_vect(jaccard_metric_v, true);

      sort_metric_vect(dominance_metric_v, false);
      sort_metric_vect(barinel_metric_v, false);
      sort_metric_vect(dice_metric_v, false);
      sort_metric_vect(kulczynski2_metric_v, false);
      sort_metric_vect(overlap_metric_v, false);
      sort_metric_vect(goodman_metric_v, false);
      sort_metric_vect(M2_metric_v, false);
      sort_metric_vect(rogersTanimoto_metric_v, false);
      sort_metric_vect(simpleMatching_metric_v, false);
      sort_metric_vect(anderberg_metric_v, false);
      sort_metric_vect(ochiai_metric_v, false);

      cout << "+++++ GP13 ++++ " << endl;
      sort_metric_vect(gp13_metric_v, true);

      cout << "+++++ AMPLE ++++ " << endl;
      sort_metric_vect(ample_metric_v, true);
      sort_metric_vect(naish1_metric_v, false);
      sort_metric_vect(naish2_metric_v, false);
      sort_metric_vect(ER1b_metric_v, false);
   }
   // AHP
   cout << "+++++ AHP ++++ " << endl;
   sort_metric_vect(AHP_cost_v, true);

//	Dice, Kulczynski2, Overlap, Goodman, M_Two, RogersTanimoto, SimpleMatching

   int faults[faults_SIZE];

   for( int i = 0; i < faults_SIZE; i++ )
   {
      is_fault_inserted_in_file.push_back(false);
   }
   cout << "+++++ NUMBER OF FAULTS " << faults_SIZE << endl;
   for( int i = 0; i < faults_SIZE; i++ )
   {
      faults[i] = atoi(argv[4 + i + 1]);
      cout << "## faults[" << i << "] >> " << faults[i] << endl;

      cout << "+++++ AHP exam scores " << endl;
      calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, AHP, faults[i]);
      if( !use_AHP_only )
      {
         cout << "+++++ Tarantula exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Tarantula, faults[i]);

         cout << "+++++ Ochiai exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Ochiai, faults[i]);
         //*
         cout << "+++++ Ochiai2 exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Ochiai2, faults[i]); //

         cout << "+++++ GP13 exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, GP13, faults[i]);

         cout << "+++++ Naish1 exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Naish1, faults[i]);

         cout << "+++++ Naish2 exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Naish2, faults[i]);

         cout << "+++++ Kulczynski2 exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Kulczynski2, faults[i]);

         cout << "+++++ Anderberg exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Anderberg, faults[i]);

         cout << "+++++ Jaccard exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Jaccard, faults[i]);

         cout << "+++++ Ample exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Ample, faults[i]);

         cout << "+++++ RogersTanimoto exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, RogersTanimoto, faults[i]);

         cout << "+++++ Dice exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Dice, faults[i]);

         cout << "+++++ Goodman exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Goodman, faults[i]);

         cout << "+++++ Overlap exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Overlap, faults[i]);

         cout << "+++++ SimpleMatching exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, SimpleMatching, faults[i]);

         cout << "+++++ M_Two exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, M_Two, faults[i]);

         // TODO
         cout << "+++++ Dominance exam scores " << endl;
         //  calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Dominance, faults[i]);

         cout << "+++++ Barinel exam scores " << endl;
         // calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, Barinel, faults[i]);

         cout << "+++++ ER1b exam scores " << endl;
         calc_ExamScores_metric(res_Dir, root_benchs_Dir, file_in_dataset_Dir, ER1b, faults[i]);
      }
   }
   // ------ End timer only resolution ------
   t2 = clock();
   elapsed_time = (float)(t2 - t1) / CLOCKS_PER_SEC;
   printf("CPU Time Localization = %f\n", elapsed_time);

   // ------ End timer (Total) ------
   getrusage(RUSAGE_SELF, &usage);
   end = usage.ru_utime;
   printf("USER Time (Total) =  %ld.%lds\n", end.tv_sec, end.tv_usec);

///-------------------------------------///------------------------------

   return 0;
}
///---- End Main() ----///

void normalizeMetric(std::vector<std::pair<int, double> > &metric_vals, bool display)
{
// copying vector
   vector<double> tmp_vector00;
   for( int i = 0; i < nbItems; i++ )
   {
      tmp_vector00.push_back(metric_vals.at(i).second);
   }
   cout << endl;

   if( display )
   {
      for( int i = 0; i < nbItems; i++ )
      {
         cout << tmp_vector00.at(i) << " ";
      }
   }
//	cout << "\n------------------------" << endl;

// Get max value
   vector<double>::iterator max00;
   max00 = std::max_element(tmp_vector00.begin(), tmp_vector00.end());
//	cout << "MAX metric value >>>>  " << *max00 << endl;

//	cout << "Start normalizing metric VECTOR.... " << endl;
// Get min value
   vector<double>::iterator min00;
   min00 = std::min_element(tmp_vector00.begin(), tmp_vector00.end());
//	cout << "MIN metric value >>>>  " << *min00 << endl;

   double normalized00;
// Calc normalized scores
   for( int i = 0; i < nbItems; i++ )
   {
      normalized00 = (tmp_vector00.at(i) - *min00) / (*max00 - *min00);
      if( normalized00 == 0.0 )
         normalized00 = 0.001;
      metric_vals.at(i).second = normalized00;
   }
//	cout << "\n------------------------" << endl;
   if( display )
   {
      for( int i = 0; i < nbItems; i++ )
      {
         cout << metric_vals.at(i).second << " ";
      }
   }
//	cout << "\n####################################\n\n" << endl;
   tmp_vector00.clear();
}
//--------------------------------------------------
//--------------------------------------------------
void removeIntersecteD(VECELE& delta, VECELE& ranked)
{
   for( unsigned int i = 0; i < delta.size(); i++ )
   {
      if( (ranked[delta[i]] == 1) )
      {
         delta.erase(delta.begin() + i);
      }
   }
}
//--------------------------------------------------
VECELE computeDeltaD(VECELE & Omega, VECELE & SMi)
{
   VECELE deltaD00;
   for( unsigned int i = 0; i < Omega.size(); i++ )
   {
      if( (Omega[i] == 1) && (SMi[i] == 0) )
      {
         deltaD00.push_back(i);
      }
   }
   return deltaD00;
}
//--------------------------------------------------
bool containsValue(vector<int> v, int x)
{
   for( unsigned int i = 0; i < v.size(); i++ )
   {
      if( v[i] == x )
         return true;
   }
   return false;
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------

// Compute P_Exam
/**
 * @param fault
 * @param number of statement of the program
 * @param ranking of statement according to a measure
 * @return P_Exam in %
 **/
int compute_P_Rank(int faulty_statement, VECELE Ranking)
{
   int p_rank = 0; // rank pessimistic
   int p_rank_tmp = 0; // temporary rank including separator
   int number_separator = 0;
   double p_exam = 0.0; // p score
// search the faulty statement
   for( unsigned int i = 0; i < Ranking.size(); i++ )
   {
      if( Ranking[i] == -1 )
      {
         number_separator++; // count separator
      }
      else if( Ranking[i] + 1 == faulty_statement )
      {
         p_rank_tmp = i; // rank of fault
         break;
      }
   }
// while there are stataments in the same group add there number
   int k = p_rank_tmp;
   int counter = 0;
   while( Ranking[k + 1] != -1 )
   { // while there is statement before find the separator
      counter++;
      k++;
   }
   p_rank_tmp += counter;
   p_rank = (p_rank_tmp + 1) - number_separator; // Exact rank without separator
   return p_rank;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
double compute_Exonerated_stmt(VECELE top1_pattern, int Number_of_statement)
{
   double exam = 0.0;
   int number_zero = 0;
   for( unsigned int i = 0; i < top1_pattern.size(); i++ )
   {
      if( top1_pattern[i] == 0 )
      {
         number_zero++;
      }
   } //end for
// compute % of statements not in top 1 pattern
   exam = ((double)(number_zero / (double)Number_of_statement) * 100);
   return exam;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
int compute_P_Rank_FCPminer(
   int faulty_statement,
   VECELE top1_pattern,
   std::vector<std::pair<int, double> > sorted_metric,
   VECELE& merged_top1,
   bool use_merged_top1)
{
   int p_rank = 0;
   int p_rank_tmp = 0;
   double metric_value = 0.0;
   int number_zero_separator = 0;
   double p_exam = 0.0;
//-----------------------
   bool fault_found = false;
   for( unsigned int i = 0; i < statements.size(); i++ )
   {
      if( top1_pattern[statements[i]] == 0 )
      {
         number_zero_separator++;
      }
      else if( (statements[i] + 1) == faulty_statement )
      {
         p_rank_tmp = i;
         fault_found = true;
         break;
      }
   }

   if( !fault_found )
      return -1;
//-----------------------
// while there are stataments in the same group add there number
   int k = p_rank_tmp;
   int counter = 0;

   while( k < (statements.size() - 1) && (statement_metrix[p_rank_tmp] == statement_metrix[k + 1]) )
   { // while there is statement before find the separator
      if( top1_pattern[statements[k + 1]] == 1 )
      {
         // Counting instructions appearing only in top1 pattern
         counter++;
      }
      k++;
   }
   p_rank_tmp += counter;
   p_rank = (p_rank_tmp + 1) - number_zero_separator; // Exact rank without separator

//-------------------------------------
// P_exam par rapport à merged top1
//-------------------------------------
   if( use_merged_top1 )
   {
      //C- compute offset of non-localized fault in top1
      // a- compute sum of already visited stmts
      int sum_visited_stmt = accumulate(merged_top1.begin(), merged_top1.end(), 0);

      //b- compute the number stmts preceding the fault (using it P_rank) and being in merged_top1
      int nb_stmt_preced_fault = 0;

      for( unsigned int i = 0; i < p_rank - 1; i++ )
      {
         if( merged_top1[statements[i]] == 1 )
         {
            nb_stmt_preced_fault++;
         }
      }	// end-for
      // c- compute the offset
      int offset = sum_visited_stmt - nb_stmt_preced_fault;
      p_rank += offset;
   }

   return p_rank;
//-------------------------------------
//-------------------------------------

}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
int compute_O_Rank_FCPminer(
   int faulty_statement,
   VECELE top1_pattern,
   std::vector<std::pair<int, double> > sorted_metric,
   VECELE& merged_top1,
   bool use_merged_top1)
{
   int o_rank = 0;
   int o_rank_tmp = 0;
   double metric_value = 0.0;
   int number_zero_separator = 0;
   double o_exam = 0.0;
//-----------------------
   bool fault_found = false;
   for( unsigned int i = 0; i < statements.size(); i++ )
   {
      // sorted_metric.at(i).first
      if( top1_pattern[statements[i]] == 1 ) // stmt appears in top1 pattern
         if( (statements[i] + 1) == faulty_statement )
         {
            o_rank_tmp = i;
//				cout << "metric_value " << metric_value << endl;
            fault_found = true;
            break;
         }
   }
   if( !fault_found )
      return -1;
//-----------------------
// while there are stataments in the same group add their number
   int k = o_rank_tmp;
   int counter = 0;

   while( (k > 0) && (statement_metrix[o_rank_tmp] == statement_metrix[k - 1]) )
   { // while there is statement before find the separator
      counter++;
      k--;
   }
   o_rank_tmp -= counter;

   for( unsigned int i = 0; i < o_rank_tmp; i++ )
   {
      // Counting instructions preceding the fault and not in top1 pattern
      if( top1_pattern[statements[i]] == 0 )
      {
         number_zero_separator++;
      }
   }	// end-for

   o_rank = (o_rank_tmp + 1) - number_zero_separator; // Exact rank without separator
//-------------------------------------
// O_exam par rapport à merged top1
//-------------------------------------
   if( use_merged_top1 )
   {
      //C- compute offset of non-localized fault in top1
      // a- compute sum of already visited stmts
      int sum_visited_stmt = accumulate(merged_top1.begin(), merged_top1.end(), 0);

//		cout << "sum_visited_stmt " << sum_visited_stmt << endl;

      //b- compute the number stmts preceding the fault (using it P_rank) and being in merged_top1
      int nb_stmt_preced_fault = 0;

      for( unsigned int i = 0; i < o_rank - 1; i++ )
      {
         if( merged_top1[statements[i]] == 1 )
         {
            nb_stmt_preced_fault++;
         }
      }	// end-for
//		cout << "nb_stmt_preced_fault " << nb_stmt_preced_fault << endl;

      // c- compute the offset
      int offset = sum_visited_stmt - nb_stmt_preced_fault;
      o_rank += offset;
//		cout << "offset " << offset << endl;
   }
//-------------------------------------
//-------------------------------------
   return o_rank;
}

//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
int compute_metric_O_Rank(int faulty_statement, std::vector<std::pair<int, double> > sorted_metric)
{
   int o_rank = 0;
   double metric_value = 0.0;
   double o_exam = 0.0;
//-----------------------
   for( unsigned int i = 0; i < sorted_metric.size(); i++ )
   {
      if( (sorted_metric.at(i).first + 1) == faulty_statement )
      {
         /*
          cout << "\t\t ### Trouvée: " << (sorted_metric.at(i).first + 1)
          << " metric value: " << sorted_metric.at(i).second << endl;
          */
         o_rank = i;
         metric_value = sorted_metric.at(i).second;
         break;
      }
   }
//-----------------------
   int k = o_rank;
   int counter = 0;
   while( k > 0 && (sorted_metric.at(k - 1).second == metric_value) )
   {
      counter++;
      k--;
   }
   o_rank -= counter;
   return o_rank + 1;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
int compute_metric_P_Rank(int faulty_statement, std::vector<std::pair<int, double> > sorted_metric)
{
   int p_rank = 0;
   double metric_value = 0.0;
   double p_exam = 0.0;
//-----------------------
   for( unsigned int i = 0; i < sorted_metric.size(); i++ )
   {

      if( (sorted_metric.at(i).first + 1) == faulty_statement )
      {
         p_rank = i;
         metric_value = sorted_metric.at(i).second;
         break;
      }
   }
   cout << endl;
//-----------------------
// while there are stataments in the same group add there number
   int k = p_rank;
   int counter = 0;

   while( k < (sorted_metric.size() - 1) && (sorted_metric.at(k + 1).second == metric_value) )
   { // while there is statement before find the separator
      counter++;
      k++;
   }
   p_rank += counter;
   return p_rank + 1;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
double compute_Exam(int rank, int Number_of_statement)
{
   double exam = 0.0;
   exam = ((double)(rank / (double)Number_of_statement) * 100);
   return exam;
}
//---------------------------------------------------------
//---------------------------------------------------------
//---------------------------------------------------------
