#include "timer.hpp"
 
unsigned int time_to_timeout = 1;

void timeout_reached(int value) {
  printf("TIMEOUT\n");
  exit(0);
}

// Will stop when the amount of time used by the process, either for itself or for system calls, will be >= seconds
void setusertimeout(long seconds) {
  struct itimerval itimeout;

  if (signal(SIGVTALRM, timeout_reached) == SIG_ERR) {
    fprintf(stderr, "Trouble 3 issue on signal handler installation (timeout.c).\n");
    exit;
  }
  
  itimeout.it_interval.tv_sec = 0;
  itimeout.it_interval.tv_usec = 0;
  itimeout.it_value.tv_sec = time_to_timeout = seconds;
  itimeout.it_value.tv_usec = 0;
  
  if (setitimer(ITIMER_VIRTUAL, &itimeout, NULL) != 0) {
    fprintf(stderr, "Trouble 4 issue on setting timeout timer (timeout.c).\n");
    exit;
  }
}

void settimeout(long seconds) {
  struct itimerval itimeout;
  if (signal(SIGPROF, timeout_reached) == SIG_ERR) {
    fprintf(stderr, "Trouble 1 issue on signal handler installation (timeout.c).\n");
    getchar();
    exit;
  }
  
  itimeout.it_interval.tv_sec = 0;
  itimeout.it_interval.tv_usec = 0;
  itimeout.it_value.tv_sec = time_to_timeout = seconds;
  itimeout.it_value.tv_usec = 0;
  
  if (setitimer(ITIMER_PROF, &itimeout, NULL) != 0) {
    fprintf(stderr, "Trouble 2 issue on setting timeout timer (timeout.c).\n");
    exit;
  }
}

//--------------------------------------------------
// pour récupérer le temps "réel" utilisateur
//--------------------------------------------------

void init_time(double &start_time0)
{
  struct rusage my_usage;
  getrusage(RUSAGE_SELF, &my_usage);
  start_time0 = my_usage.ru_utime.tv_sec*(1e+6) + my_usage.ru_utime.tv_usec;
}



double end_time(double &start_time)
{
  struct rusage my_usage;
  time_t time2;
  getrusage(RUSAGE_SELF, &my_usage);
  double time_left = ((my_usage.ru_utime.tv_sec*(1e+6) + my_usage.ru_utime.tv_usec) - start_time)/(1e+6);
  return time_left;
}


//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------
//--------------------------------------------------

/*
main() {
  // fixer le time out
  setusertimeout(10);
  settimeout(10);
  //
  printf("Le programme s'arrêtera dans 10 secs ! Promis !\n");
  init_time();
  //long tm0 = end_time();
  //long tm1 = end_time();
  /*for (;;) {
    tm1 = end_time();
    for (int i=0; i<1000000; i++) {};
    if (tm1 != tm0) {
      printf("Le temps courant est : %d\n", tm1);
      tm0 = tm1;
    }
  }*/
/*  int x;
  for (int i=0; i<1000000000; i++) {x = x+2;};
  long tm1 = end_time();
  printf("Le temps d'exécution : %d\n", tm1);


}
*/
